#include "core.h"

Core::Core(QObject *parent):
  QObject(parent)
  {
  #ifdef CORE_USE_THREAD
  m_worker=new Thread(this);
  #else
  m_worker=new Worker(this);
  #endif
  connect(m_worker,SIGNAL(result(Ticket,CustomNumber)),this,SLOT(workerResult(Ticket,CustomNumber)));
  QTimer::singleShot(0,this,SLOT(run()));
  }

void Core::run(void)
  {
  QTextStream stream(stdout);
  CustomNumber a("a",6);
  CustomNumber b("b",8);
  Ticket ticket;

  stream << "A: " << a.value() << " " << a.string() << "\n";
  stream << "B: " << b.value() << " " << b.string() << "\n";
  stream << "Ticket: " << ticket.index() << "\n\n";
  stream.flush();

  m_worker->average(ticket,a,b);
  m_ticket_list.append(ticket);
  }


void Core::workerResult(const Ticket &ticket,const CustomNumber &r)
  {
  QTextStream stream(stdout);

  if(m_ticket_list.contains(ticket))
    {
    m_ticket_list.removeAll(ticket);
    stream<<"Result value: "<< r.value() << " " << r.string() <<"\n";
    stream << "Ticket: " << ticket.index() << "\n\n";
    stream.flush();

    emit quit();
    }
  }
