#ifndef CUSTOMNUMBER_H
  #define CUSTOMNUMBER_H

  #include <QtGlobal>
  #include <QString>
  #include <QMetaType>

  class CustomNumber
    {
    public:
      CustomNumber(const QString &string=QString(),quint32 value=0); // Public default constructor
      CustomNumber(const CustomNumber &other);                       // Public copy constructor
      ~CustomNumber();                                               // Public destructor

      QString string(void) const;
      void setString(const QString &string);

      quint32 value(void) const;
      void setValue(quint32 value);

      CustomNumber &operator=(const CustomNumber &other);
      bool operator==(const CustomNumber &other) const;
      bool operator!=(const CustomNumber &other) const;

    public:
      static void registerMetaType(void);

    private:
      QString m_string;
      quint32 m_value;

    };

  Q_DECLARE_METATYPE(CustomNumber)

#endif // CUSTOMNUMBER_H
