#include "thread.h"

Thread::Thread(QObject *parent):
  AbstractWorker(parent)
  {
  m_thread=new QThread();
  m_worker=new Worker();

  m_worker->moveToThread(m_thread);

  connect(m_thread,SIGNAL(finished()),m_worker,SLOT(deleteLater()));
  connect(m_worker,SIGNAL(result(Ticket,CustomNumber)),this,SIGNAL(result(Ticket,CustomNumber)));
  m_thread->start();
  }

Thread::~Thread()
  {
  m_thread->quit();
  m_thread->wait();
  m_thread->deleteLater();
  }

void Thread::average(const Ticket &ticket,const CustomNumber &a,const CustomNumber &b)
  {
  QMetaObject::invokeMethod(m_worker,"average",Qt::QueuedConnection,Q_ARG(Ticket,ticket),Q_ARG(CustomNumber,a),Q_ARG(CustomNumber,b));
  }
